<?php
namespace common\models\forms;

use common\helpers\Cache;
use common\helpers\Date;
use common\components\Model;
use common\helpers\Form;
use common\helpers\user\Balance;
use common\helpers\user\Cash;
use common\helpers\user\Info;
use common\libs\logging\operate\AdminOperate;
use common\models\DealType;
use common\models\Order;
use common\models\OrderGoods;
use common\models\Period;
use common\models\ReceiveAddress;
use common\models\Region;
use common\models\ShopGoods;
use common\models\User;
use common\models\UserNetwork;
use common\models\RemainPv;
use common\models\FlowRemainPv;
use yii\base\Exception;

/**
 * Login form
 */
class OrderForm extends Model
{
    public $sn;
    public $expressCompany;
    public $orderTrackNo;
    public $status;
    public $remark;

    public $type;
    public $addressId;
    public $payType;
    public $goodsId;
    public $goodsNum;
    public $payPassword;

    public $userName;
    public $consignee;
    public $acceptMobile;
    public $province;
    public $city;
    public $county;
    public $detailaddress;

    private $_address;
    private $_decAmount;
    private $_decPv;
    private $_freight;
    private $_payAmount;
    private $_orderGoods;
    private $_remainPv;
    private $_realPv;

    /**
     * @var Order
     */
    private $_model;

    public function init() {
        parent::init();
        $this->adminOperateLogger = new AdminOperate([
            'fetchClass' => Order::class,
        ]);
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['sn', 'expressCompany', 'orderTrackNo', 'status', 'remark','type','addressId','payType','goodsId','goodsNum', 'payPassword','userName','consignee','acceptMobile','province','city','county','detailaddress'], 'trim'],
            [['sn', 'expressCompany', 'orderTrackNo', 'status', 'remark','type','addressId','payType','goodsId','goodsNum', 'payPassword','userName','consignee','acceptMobile','province','city','county','detailaddress'], 'required'],
            [['status'], 'isStatus'],
            [['addressId'], 'isAddress'],
            [['payType'], 'isPayType'],
            [['payPassword'], 'validatePassword'],
        ];
    }

    public function attributeLabels()
    {
        return [
            'sn' => '订单号',
            'expressCompany' => '快递公司',
            'orderTrackNo' => '快递单号',
            'status' => '状态',
            'remark' => '备注',
            'type' => '订单类型',
            'addressId' => '收货地址',
            'payType' => '支付方式',
            'goodsId' => '商品ID',
            'goodsNum' => '商品数量',
            'userName' => '复消会员编号',
            'consignee' => '收货人',
            'acceptMobile' => '收货电话',
            'province' => '省',
            'city' => '市',
            'county' => '区',
            'detailaddress' => '收货详细地址',
        ];
    }

    /**
     * 指定校验场景
     * @return array
     */
    public function scenarios()
    {
        $parentScenarios =  parent::scenarios();
        $customScenarios = [
            // 管理员发货
            'adminDelivery' => ['sn', 'expressCompany', 'orderTrackNo'],
            // 会员确认收货
            'userConfirm' => ['sn', 'expressCompany', 'orderTrackNo'],
            // 管理员修改订单状态
            'adminStatus' => ['sn', 'status'],
            // 管理员修改备注
            'adminRemark' => ['sn', 'remark'],
            // 会员下单
            'userOrder' => ['type','addressId', 'payType','goodsId','goodsNum', 'remark', 'payPassword'],
            // 帮会员复消下单
            'reconsumeOrder' => ['type','userName', 'payType','goodsId','goodsNum', 'remark', 'payPassword','consignee','acceptMobile','province','city','county','detailaddress'],
        ];
        return array_merge($parentScenarios, $customScenarios);
    }

    /**
     * 校验之前
     * @return bool
     */
    public function beforeValidate()
    {
        $parentValidate = parent::beforeValidate();
        if ($this->sn) {
            $this->_model = Order::findOne(['SN'=>$this->sn]);
            if (!$this->_model){
                $this->addError('sn', '订单不存在');
                return false;
            }
        }
        if ($this->scenario == 'adminDelivery'){
            if($this->_model['STATUS'] == \Yii::$app->params['orderStatus']['cancel']) {
                $this->addError('sn', '订单已取消不能发货');
                return false;
            }
            if($this->_model['STATUS'] == \Yii::$app->params['orderStatus']['del']) {
                $this->addError('sn', '订单已删除不能发货');
                return false;
            }
        }

        return $parentValidate;
    }

    /**
     * 校验支付密码
     * @param $attribute
     * @param $params
     */
    public function validatePassword($attribute, $params) {
        if (!User::validatePayPassword(\Yii::$app->user->id, $this->payPassword)) {
            $this->addError($attribute, '支付密码不正确');
        }
    }

    /**
     * 判断收货地址是否存在
     * @param $attribute
     */
    public function isAddress($attribute){
        if (!$receiveAddress = ReceiveAddress::find()->where(' ID=:ID', [':ID' => $this->addressId])->asArray()->one()) {
            $this->addError($attribute, '收货地址不存在');
        } else {
            $this->_address = $receiveAddress;
        }
    }

    /**
     * 判断支付方式
     * @param $attribute
     */
    public function isPayType($attribute){
        if(!array_key_exists($this->payType, ShopGoods::getPayMethod())){
            $this->addError($attribute, '支付方式错误');
            return;
        }
    }

    /**
     * 校验类型
     * @param $attribute
     */
    public function isStatus($attribute){
        if(!in_array($this->type, \Yii::$app->params['orderStatus'])){
            $this->addError($attribute, '类型错误');
            return ;
        }
        if ($this->scenario == 'adminStatus'){
            if ($this->status == $this->_model['STATUS']) {
                $this->addError($attribute, '订单状态没有改变');
                return ;
            }
            if($this->status == \Yii::$app->params['orderStatus']['notPaid'] && $this->_model['STATUS'] >= \Yii::$app->params['orderStatus']['delivery']) {
                $this->addError($attribute, '订单已经进入物流状态不能改为未支付');
                return ;
            }
            elseif($this->status == \Yii::$app->params['orderStatus']['paid'] && $this->_model['STATUS'] >= \Yii::$app->params['orderStatus']['cancel']) {
                $this->addError($attribute, '订单已失效不能处理');
                return ;
            }
            elseif($this->status == \Yii::$app->params['orderStatus']['delivery']) {
                $this->addError($attribute, '订单不能单独处理为物流状态');
                return ;
            }
            elseif($this->status == \Yii::$app->params['orderStatus']['complete'] && $this->_model['STATUS'] > \Yii::$app->params['orderStatus']['cancel']) {
                $this->addError($attribute, '订单已失效不能处理');
                return ;
            }
            elseif($this->status == \Yii::$app->params['orderStatus']['cancel']) {
                if($this->_model['STATUS'] == \Yii::$app->params['orderStatus']['complete']) {
                    $this->addError($attribute, '订单已完成不能取消');
                    return ;
                }
                if($this->_model['STATUS'] == \Yii::$app->params['orderStatus']['del']) {
                    $this->addError($attribute, '订单已删除不能取消');
                    return ;
                }
            }
            elseif($this->status == \Yii::$app->params['orderStatus']['del']) {
                if($this->_model['STATUS'] == \Yii::$app->params['orderStatus']['complete']) {
                    $this->addError($attribute, '订单已完成不能删除');
                    return ;
                }
            }
        }

    }

    /**
     * 管理员发货
     * @return Order|null
     * @throws \yii\db\Exception
     */
    public function adminDelivery(){
        if(!$this->validate()){
            return null;
        }
        $db = \Yii::$app->db;
        $transaction = $db->beginTransaction();
        try {
            $period = Period::instance();
            $this->_model->DELIVERY_STATUS = \Yii::$app->params['deliveryStatus']['delivered']['value'];
            $this->_model->DELIVERY_PERIOD = $period->getNowPeriodNum();
            $this->_model->DELIVERY_AT = Date::nowTime();
            $this->_model->EXPRESS_COMPANY = $this->expressCompany;
            $this->_model->ORDER_TRACK_NO = $this->orderTrackNo;
            $this->_model->STATUS = \Yii::$app->params['orderStatus']['delivery']['value'];
            if(!$this->_model->save()){
                throw new Exception(Form::formatErrorsForApi($this->_model->getErrors()));
            }
            $transaction->commit();
        } catch (Exception $e) {
            $transaction->rollBack();
            $this->addError('edit', $e->getMessage());
            return null;
        }
        return $this->_model;
    }

    /**
     * BV分期
     *
     *
     */
    private function _pvSplit($oPv){
        $sysConfig = Cache::getSystemConfig();
        $mesureUpCondition =  $sysConfig['monthPcsPvFxCondition']['VALUE'];
        if($oPv>$mesureUpCondition){
            $currentPv = $oPv % $mesureUpCondition + $mesureUpCondition;
            $remainPv = $oPv - $currentPv;
        }else{
            $currentPv = $oPv;
            $remainPv = 0;
        }
        return [
            'current' => $currentPv,
            'remain' => $remainPv
        ];
    }

    /**
     * 复销
     * @return bool|null
     * @throws Exception
     * @throws \yii\db\Exception
     */
    public function add(){
        if(!$this->validate()){
            return null;
        }
        $ids = $this->goodsId;
        $totalAmount = 0;
        $totalPv = 0;
        $totalRealPv = 0;
        $this->_remainPv = 0;
        $cateId = [];
        foreach ($this->goodsNum as $k => $v) {
            if ($v) {
                $goods = ShopGoods::findOneAsArray('ID=:ID AND STATUS=1',[':ID'=> $ids[$k]]);
                if (!$goods) {
                    throw new Exception('商品不存在');
                }
                $cateId[] = $goods['CATE_ID'];
                if($goods['STORE_NUMS']>0){
                    $discount = $goods['SELL_DISCOUNT'];
                    $realPrice = $goods['SELL_PRICE'] * $discount;
                    $realPv = $goods['PRICE_PV'] * $discount;
                    if($goods['PV_SPLIT']==1){ // 当商品为PV分期时
                        $pvSplit = $this->_pvSplit($realPv);
                        $currentPv = $pvSplit['current'];
                        $remainPv = $pvSplit['remain'];
                        $totalPv += $currentPv * intval($v);
                        $totalRealPv += $realPv * intval($v);
                        $this->_remainPv += $remainPv * intval($v);
                    }else{
                        $currentPv = $goods['PRICE_PV'];
                        $totalPv += $realPv * intval($v);
                        $totalRealPv += $realPv * intval($v);
                        $remainPv = 0;
                        $this->_remainPv += 0;
                    }
                    $totalAmount += $realPrice * intval($v);
                    $this->_orderGoods[] = [
                        'GOODS_ID' => $goods['ID'],
                        'PRICE' => $goods['SELL_PRICE'],
                        'PV' => $currentPv, // $goods['PRICE_PV'],
                        'REAL_PRICE' => $realPrice,
                        'REAL_PV' => $realPv,
                        'REMAIN_PV' => $remainPv,
                        'POINT' => $goods['POINT'],
                        'BUY_NUMS' => intval($v),
                        'SKU_CODE' => $goods['GOODS_NO'],
                        'GOODS_TITLE' => $goods['GOODS_NAME']
                    ];
                }
            }
        }

        if (count(array_unique($cateId)) > 1) {
            throw new Exception('海内商品、海外商品只能选择一种');
        }

        $this->_decAmount = $totalAmount;
        $this->_decPv = $totalPv;
        $this->_realPv = $totalRealPv;
        $this->_freight = ($totalAmount>=300) ? 0 : 15;
        $this->_payAmount = $this->_decAmount + $this->_freight;


        $db = \Yii::$app->db;
        $transaction = $db->beginTransaction();
        try {
            //判断用户余额是否充足
            $loginUserId = \Yii::$app->user->id;
            if($this->payType=='cash') {
                if (Cash::getAvailableBalance($loginUserId) < $this->_payAmount) {
                    throw new Exception('余额不足，无法购买商品');
                }
            } else if ($this->payType =='exchange') {
                if ($this->_payAmount > Balance::getBalanceExchangePoints($loginUserId)) {
                    throw new Exception('兑换点数不足，无法购买商品');
                }
            } else{
                if ($this->_payAmount > Balance::getBalanceReconsumePoints($loginUserId)) {
                    throw new Exception('复销点数不足，无法购买商品');
                }
            }

            /**
             * 2022-04-28
             * York
             * 支付后减少库存
             */
            foreach ($this->goodsNum as $k => $v){
                if ($v){
                    $goods = ShopGoods::findOneAsArray('ID=:ID AND STATUS=1',[':ID'=> $ids[$k]]);
                    if (!$goods) {
                        throw new Exception('商品不存在');
                        return;
                    }
                    if ($goods['STORE_NUMS'] >= $this->goodsNum[$k]){
                        $data = ShopGoods::find()->where(['ID' => $ids[$k]])->one();
                        $goods_store_nums = $data->STORE_NUMS - $this->goodsNum[$k];
                        $data->STORE_NUMS = $goods_store_nums;
                        $data->update();
                        //下单后库存小于等于0 商品下架
                        if($goods_store_nums <= 0){
                            $data->STATUS = 0;
                            $data->UPDATED_AT = Date::nowTime();
                            $data->update();

                        }
                    }else{
                        throw new Exception($goods['GOODS_NAME'].'库存不足，无法购买商品');

                    }


                }
            }
//                exit();
            //写入订单
            if (!$orderResult = $this->addOrder()) {
                throw new Exception(Form::formatErrorsForApi($orderResult->getErrors()));
            }
            $transaction->commit();
        }catch (\Exception $e){
            $transaction->rollBack();
            $this->addError('add', $e->getMessage());
            return null;
        }
        return true;
    }

    /**
     * 复销订单
     */
    public function addOrder(){
        $periodObj = Period::instance();
        $nowPeriodNum = $periodObj->getNowPeriodNum();
        $nowCalcMonth = $periodObj->getYearMonth($nowPeriodNum);

        $userId = \Yii::$app->user->id;
        $userName = Info::getUserNameByUserId($userId);

        // 加入订单信息
        $warehouse = Region::getWarehouseByCode($this->_address['PROVINCE']);//仓库
        if(!$warehouse){
            throw new Exception('地区暂时不支持配送，具体联系客服');
        }
        $ordNo = $this->_generateSn();
        $orderModel = new Order();
        $orderModel->SN = 'OS'.$ordNo;
        $orderModel->DEC_SN = 'DS'.$ordNo;
        $orderModel->ORDER_TYPE = $this->type;
        $orderModel->USER_ID = $userId;
        $orderModel->USER_NAME = $userName;
        $orderModel->ORDER_AMOUNT = $this->_decAmount;
        $orderModel->PV = $this->payType =='exchange' ? 0 : $this->_decPv;
        $orderModel->PAY_AMOUNT = $this->_payAmount;
        $orderModel->PAY_PV = $this->payType =='exchange' ? 0 : $this->_decPv; // 兑换积分不能算业绩
        $orderModel->REMAIN_PV = $this->_remainPv;
        $orderModel->PAY_AT = Date::nowTime();
        $orderModel->PAY_TYPE = $this->payType;
        $orderModel->PERIOD_NUM = $nowPeriodNum;
        $orderModel->P_CALC_MONTH = Date::ociToDate($nowCalcMonth, Date::OCI_TIME_FORMAT_SHORT_MONTH);
        $orderModel->FREIGHT = $this->_freight;
        $orderModel->PAY_FREIGHT = $this->_freight;
        $orderModel->CONSIGNEE = $this->_address['CONSIGNEE'];
        $orderModel->MOBILE = $this->_address['MOBILE'];
        $orderModel->PROVINCE = $this->_address['PROVINCE'];
        $orderModel->CITY = $this->_address['CITY'];
        $orderModel->COUNTY = $this->_address['COUNTY'];
        $orderModel->ADDRESS = $this->_address['ADDRESS'];
        $orderModel->FRONT_REMARK = $this->remark;
        $orderModel->WAREHOUSE = $warehouse;
        $orderModel->STATUS = 1;
        $orderModel->CREATED_AT = Date::nowTime();
        $orderModel->CREATE_USER = $userName;
        if(!$orderModel->save()){
            $this->addErrors($orderModel->getErrors());
            return false;
        }
        // 加入商品到订单商品表
        foreach($this->_orderGoods as $key=>$value){
            // 增加判断,如果订单是兑换券购买,则AR_ORDER_GOODS中的REAL_PV真实PV应该是0
            if ($orderModel->PAY_TYPE == 'exchange') {
                $this->_orderGoods[$key]['REAL_PV'] = 0;
            }
            $this->_orderGoods[$key]['ORDER_SN'] = $orderModel->SN;
            $this->_orderGoods[$key]['P_CALC_MONTH'] = Date::ociToDate($nowCalcMonth, Date::OCI_TIME_FORMAT_SHORT_MONTH);
        }
        OrderGoods::batchInsert($this->_orderGoods);

        //扣除会员余额/积分
        if($this->payType=='cash') {
            Cash::changeUserCash(\Yii::$app->user->id, 'CASH', -abs($this->_payAmount), ['REMARK' => '会员复销余额支付', 'ORDER_SN' => $orderModel->SN]);
        } else if ($this->payType=='exchange') {
            Balance::changeUserBonus(\Yii::$app->user->id,'exchange_points', -abs($this->_payAmount),['DEAL_TYPE_ID' => DealType::EXCHANGE_POINTS_EXCHANGE,'REMARK' => '会员兑换积分兑换', 'ORDER_SN' => $orderModel->SN]);
        } else{
            Balance::changeUserBonus(\Yii::$app->user->id,'reconsume_points', -abs($this->_payAmount),['DEAL_TYPE_ID' => DealType::RECONSUME_POINTS_EXCHANGE,'REMARK' => '会员复销点数兑换', 'ORDER_SN' => $orderModel->SN]);
        }
        return $orderModel;
    }

    /**
     * 帮会员复销
     * @throws Exception
     * @throws \yii\db\Exception|\Throwable
     */
    public function reconsumeAdd(){
        if(!$this->validate()){
            return null;
        }
        $ids = $this->goodsId;
        $totalAmount = 0;
        $totalPv = 0;
        foreach ($this->goodsNum as $k => $v) {
            if ($v) {
                $goods = ShopGoods::findOneAsArray('ID=:ID AND STATUS=1',[':ID'=> $ids[$k]]);
                if (!$goods) {
                    throw new Exception('商品已下架');
                    return;
                }
                if($goods['STORE_NUMS']>0){
                    $discount = $goods['SELL_DISCOUNT'];
                    $realPrice = $goods['SELL_PRICE'] * $discount;
                    $realPv = $goods['PRICE_PV'] * $discount;
                    $totalAmount += $realPrice * intval($v);
                    $totalPv += $realPv * intval($v);
                    $this->_orderGoods[] = [
                        'GOODS_ID' => $goods['ID'],
                        'PRICE' => $goods['SELL_PRICE'],
                        'PV' => $goods['PRICE_PV'],
                        'REAL_PRICE' => $realPrice,
                        'REAL_PV' => $realPv,
                        'POINT' => $goods['POINT'],
                        'BUY_NUMS' => intval($v),
                        'SKU_CODE' => $goods['GOODS_NO'],
                        'GOODS_TITLE' => $goods['GOODS_NAME']
                    ];
                }
            }
        }
        $this->_decAmount = $totalAmount;
        $this->_decPv = $totalPv;
        $this->_freight = ($totalAmount>=300) ? 0 : 15;
        $this->_payAmount = $this->_decAmount + $this->_freight;

        $db = \Yii::$app->db;
        $transaction = $db->beginTransaction();
        try {
            $loginUserId = \Yii::$app->user->id;

            //是否开启伞下会员限制
            $isResaleUmbrella = Cache::getSystemConfig()['isResaleUmbrella']['VALUE'];
            if($isResaleUmbrella){
                $userId = Info::getUserIdByUserName($this->userName);
                $userNetwork = UserNetwork::find()->where("USER_ID=:USER_ID AND INSTR(PARENT_UIDS,'{$loginUserId}')>0", ['USER_ID'=>$userId])->count();
                if(!$userNetwork){
                    throw new Exception($this->userName.'不是您的伞下会员，不能为其复消！');
                }
            }
            //判断用户余额是否充足
            if($this->payType=='cash') {
                if (Cash::getAvailableBalance($loginUserId) < $this->_payAmount) {
                    throw new Exception('余额不足，无法购买商品');
                }
            }else{
                if ($this->_payAmount > Balance::getBalanceReconsumePoints($loginUserId)) {
                    throw new Exception('复销点数不足，无法购买商品');
                }
            }


            /**
             * 2022-04-28
             * York
             * 支付后减少库存
             */
            foreach ($this->goodsNum as $k => $v){
                if ($v){
                    $goods = ShopGoods::findOneAsArray('ID=:ID AND STATUS=1',[':ID'=> $ids[$k]]);
                    if (!$goods) {
                        throw new Exception('商品已下架');
                        return;
                    }
                    if ($goods['STORE_NUMS'] >= $this->goodsNum[$k]){
                        $data = ShopGoods::find()->where(['ID' => $ids[$k]])->one();
                        $goods_store_nums = $data->STORE_NUMS - $this->goodsNum[$k];
                        $data->STORE_NUMS = $goods_store_nums;
                        $data->update();
                        //下单后库存小于等于0 商品下架
                        if($goods_store_nums <= 0){
                            $data->STATUS = 0;
                            $data->UPDATED_AT = Date::nowTime();
                            $data->update();

                        }
                    }else{
                        throw new Exception($goods['GOODS_NAME'].'库存不足，无法购买商品');
                    }
                }
            }
//                exit();

            //写入订单
            if (!$orderResult = $this->addUserOrder()) {
                throw new Exception(Form::formatErrorsForApi($orderResult->getErrors()));
            }
            $transaction->commit();
        }catch (\Exception $e){
            $transaction->rollBack();
            $this->addError('add', $e->getMessage());
            return null;
        }
        return true;
    }

    /**
     * 帮会员复消的订单
     * @throws Exception
     */
    public function addUserOrder(){
        $periodObj = Period::instance();
        $nowPeriodNum = $periodObj->getNowPeriodNum();
        $nowCalcMonth = $periodObj->getYearMonth($nowPeriodNum);
        //帮复消会员Id（登陆会员）
        $loginUserId = \Yii::$app->user->id;
        $loginUserName = Info::getUserNameByUserId($loginUserId);
        //订单会员Id
        $userId = Info::getUserIdByUserName($this->userName);

        // 加入订单信息
        $warehouse = Region::getWarehouseByCode($this->province);//仓库
        if(!$warehouse){
            throw new Exception('地区暂时不支持配送，具体联系客服');
        }
        $ordNo = $this->_generateSn();
        $orderModel = new Order();
        $orderModel->SN = 'OS'.$ordNo;
        $orderModel->DEC_SN = 'DS'.$ordNo;
        $orderModel->ORDER_TYPE = $this->type;
        $orderModel->ORDER_CATEGORY = 'STUDIO';
        $orderModel->USER_ID = $userId;
        $orderModel->USER_NAME = $this->userName;
        $orderModel->ORDER_AMOUNT = $this->_decAmount;
        $orderModel->PV = $this->_decPv;
        $orderModel->PAY_AMOUNT = $this->_payAmount;
        $orderModel->PAY_PV = $this->_decPv;
        $orderModel->PAY_AT = Date::nowTime();
        $orderModel->PAY_TYPE = $this->payType;
        $orderModel->PERIOD_NUM = $nowPeriodNum;
        $orderModel->P_CALC_MONTH = Date::ociToDate($nowCalcMonth, Date::OCI_TIME_FORMAT_SHORT_MONTH);
        $orderModel->FREIGHT = $this->_freight;
        $orderModel->PAY_FREIGHT = $this->_freight;
        $orderModel->CONSIGNEE = $this->consignee;
        $orderModel->MOBILE = $this->acceptMobile;
        $orderModel->PROVINCE = $this->province;
        $orderModel->CITY = $this->city;
        $orderModel->COUNTY = $this->county;
        $orderModel->ADDRESS = $this->detailaddress;
        $orderModel->FRONT_REMARK = $this->remark;
        $orderModel->WAREHOUSE = $warehouse;
        $orderModel->STATUS = 1;
        $orderModel->CREATED_AT = Date::nowTime();
        $orderModel->CREATE_USER = $loginUserName;
        if(!$orderModel->save()){
//            $this->addErrors($orderModel->getErrors());
            throw new Exception($orderModel->getErrors());
//            return false;
        }
        // 加入商品到订单商品表
        foreach($this->_orderGoods as $key=>$value){
            $this->_orderGoods[$key]['ORDER_SN'] = $orderModel->SN;
            $this->_orderGoods[$key]['P_CALC_MONTH'] = Date::ociToDate($nowCalcMonth, Date::OCI_TIME_FORMAT_SHORT_MONTH);
        }
        OrderGoods::batchInsert($this->_orderGoods);

        //扣除会员余额/积分
        if($this->payType=='cash') {
            Cash::changeUserCash($loginUserId, 'CASH', -abs($this->_payAmount), ['REMARK' => '会员复销余额支付', 'ORDER_SN' => $orderModel->SN]);
        }else{
            Balance::changeUserBonus($loginUserId,'reconsume_points', -abs($this->_payAmount),['DEAL_TYPE_ID' => DealType::RECONSUME_POINTS_EXCHANGE, 'REMARK' => '会员复销点数兑换', 'ORDER_SN' => $orderModel->SN]);
        }
        return $orderModel;
    }

    /**
     * 生成流水号
     * @return string
     */
    private function _generateSn() {
        return Date::today('Ymd') . $this->_random(10, 1);
    }

    /**
     * 生成随机数
     * @param $length
     * @param int $numeric
     * @return string
     */
    private function _random($length, $numeric = 0) {
        $seed = base_convert(md5(microtime() . $_SERVER['DOCUMENT_ROOT']), 16, $numeric ? 10 : 35);
        $seed = $numeric ? (str_replace('0', '', $seed) . '012340567890') : ($seed . 'zZ' . strtoupper($seed));
        $hash = '';
        $max = strlen($seed) - 1;
        for ($i = 0; $i < $length; $i++) {
            $hash .= $seed[mt_rand(0, $max)];
        }
        return $hash;
    }

    public function addFakeOrder($userId, $periodNum){
        $userName = Info::getUserNameByUserId($userId);
        $sysConfig = Cache::getSystemConfig();
        $mesureUpCondition =  $sysConfig['monthPcsPvFxCondition']['VALUE']; // 月达标条件 NC默认300
        $ordNo = $this->_generateSn();
        $orderModel = new Order();
        $orderModel->SN = 'OS'.$ordNo;
        $orderModel->DEC_SN = 'DS'.$ordNo;
        $orderModel->USER_ID = $userId;
        $orderModel->USER_NAME = $userName;
        $orderModel->PERIOD_NUM = $periodNum;
        $orderModel->CREATE_USER = 'AUTO';
        $orderModel->ORDER_TYPE = 'FX';
        $orderModel->STATUS = 1;
        $orderModel->PV = $mesureUpCondition;
        $orderModel->PAY_PV = $mesureUpCondition;
        $orderModel->P_CALC_MONTH = '1970-01-01';
        $orderModel->CREATED_AT = Date::nowTime();
        $orderModel->EXPRESS_TYPE = 1;
        $orderModel->IS_AUTO = 1;
        if(!$orderModel->save()){
            $this->addErrors($orderModel->getErrors());
            return false;
        }
        return $orderModel;
    }
}
